(* Commands -- main commands, and loading of example programs *)

structure Commands :> Commands = struct

local 
    open Data Run Parse Compile;

    infixr seq0 seq4       
    fun e1 seq0 e2 = Case(e1, ([(e2, [])], []))
    fun e1 seq4 e2 = Case(e1, ([(e2, [1,2,3,4])], [1,2,3,4]))
in
    val memsizeprt = memsizeprt;
    val memsizelam = memsizelam;

    val readfile = readfile
    val rp  = parse o readfile
    val pc  = compile o parse
    val pcr = run o pc

    fun prtintlist e =
	Let([(Lam (Case (Var 1, ([(Prtstr "nil", []),
				  (Prtstr "(Cons " 
				   seq4 Var 2 
				   seq4 Prtint
				   seq4 Prtstr " "
				   seq4 App(Var 4, 1)
				   seq0 Prtstr ")", [1,2,3,4])], [1,2]))), 
	      [1])],
	(Let ([(e,[])], (App(Var 2, 1), [1,2])) seq0 Cst 0, [1]));

    fun prtintlist2 e =
	Let([(* prttail *)
	     (Lam (Case (Var 1, ([(Prtstr "]", []),
				  (Prtstr ","
				   seq4 Var 2 seq4 Prtint
				   seq4 App(Var 4, 1), [1,2,3,4])], [1,2]))), 
	      [1]),
	     (* prtintlist *)
	     (Lam (Case (Var 1, ([(Prtstr "[]", []),
				  (Prtstr "[" 
				   seq4 Var 2 seq4 Prtint
				   seq4 App(Var 4, 1), [1,2,3,4])], [1,2]))), 
	      [1])],
	(Let ([(e,[])], (App(Var 2, 1), [1,2])) seq0 Cst 0, [2]));

    val runlist  = run o prtintlist
    val runlist2 = run o prtintlist2
end;

end
