(* Sets of elements with equality *)

structure Eqset :> Eqset = struct

open Data;

infix 6 ++ --
type 'a set = 'a list
    
val emptyset = []
fun set x = [x]
fun mem (x, []) = false
  | mem (x, y::yr) = (x=y) orelse mem(x,yr)
fun []      ++ ys = ys
  | (x::xr) ++ ys = if mem(x,ys) then xr ++ ys else x :: (xr ++ ys)
fun []      -- ys = []
  | (x::xr) -- ys = if mem(x,ys) then xr -- ys else x :: (xr -- ys)
fun union xss = foldr (op ++) emptyset xss
fun setof xs  = union (map set xs)
fun iterset f ([],    e) = e
  | iterset f (x::xr, e) = f(x, iterset f (xr, e))
val size = length

end
